# Format is Name: [physical, short, isReadonly, location, isBitaddrable]
# Possible locations:
#   0 SFR
#   1 ESFR 
#   2 XBUS
s45_SFR = {
    "ADCIC": [0xFF98, 0xCC, False, 0, True],
    "ADCON": [0xFFA0, 0xD0, False, 0, True],
    "ADDAT": [0xFEA0, 0x50, False, 0, False],
    "ADDAT2": [0xF0A0, 0x50, False, 1, False],
    "ADDRSEL1": [0xFE18, 0x0C, False, 0, False],
    "ADDRSEL2": [0xFE1A, 0x0D, False, 0, False],
    "ADDRSEL3": [0xFE1C, 0x0E, False, 0, False],
    "ADDRSEL4": [0xFE1E, 0x0F, False, 0, False],
    "ADEIC": [0xFF9A, 0xCD, False, 0, True],
    "BUSCON0": [0xFF0C, 0x86, False, 0, True],
    "BUSCON1": [0xFF14, 0x8A, False, 0, True],
    "BUSCON2": [0xFF16, 0x8B, False, 0, True],
    "BUSCON3": [0xFF18, 0x8C, False, 0, True],
    "BUSCON4": [0xFF1A, 0x8D, False, 0, True],
    "C1BTR": [0xEF04, None, False, 2, False],
    "C1CSR": [0xEF00, None, False, 2, False],
    "C1GMS": [0xEF06, None, False, 2, False],
    "C1IR": [0xEF02, None, False, 2, False],
    "C1LAR1": [0xEF16, None, False, 2, False],
    "C1LAR2": [0xEF26, None, False, 2, False],
    "C1LAR3": [0xEF36, None, False, 2, False],
    "C1LAR4": [0xEF46, None, False, 2, False],
    "C1LAR5": [0xEF56, None, False, 2, False],
    "C1LAR6": [0xEF66, None, False, 2, False],
    "C1LAR7": [0xEF76, None, False, 2, False],
    "C1LAR8": [0xEF86, None, False, 2, False],
    "C1LAR9": [0xEF96, None, False, 2, False],
    "C1LAR10": [0xEFA6, None, False, 2, False],
    "C1LAR11": [0xEFB6, None, False, 2, False],
    "C1LAR12": [0xEFC6, None, False, 2, False],
    "C1LAR13": [0xEFD6, None, False, 2, False],
    "C1LAR14": [0xEFE6, None, False, 2, False],
    "C1LAR15": [0xEFF6, None, False, 2, False],
    "C1LGML": [0xEF0A, None, False, 2, False],
    "C1LMLM": [0xEF0E, None, False, 2, False],
    "C1MCFG1": [0xEF16, None, False, 2, False],
    "C1MCFG2": [0xEF26, None, False, 2, False],
    "C1MCFG3": [0xEF36, None, False, 2, False],
    "C1MCFG4": [0xEF46, None, False, 2, False],
    "C1MCFG5": [0xEF56, None, False, 2, False],
    "C1MCFG6": [0xEF66, None, False, 2, False],
    "C1MCFG7": [0xEF76, None, False, 2, False],
    "C1MCFG8": [0xEF86, None, False, 2, False],
    "C1MCFG9": [0xEF96, None, False, 2, False],
    "C1MCFG10": [0xEFA6, None, False, 2, False],
    "C1MCFG11": [0xEFB6, None, False, 2, False],
    "C1MCFG12": [0xEFC6, None, False, 2, False],
    "C1MCFG13": [0xEFD6, None, False, 2, False],
    "C1MCFG14": [0xEFE6, None, False, 2, False],
    "C1MCFG15": [0xEFF6, None, False, 2, False],
    "C1MCR1": [0xEF10, None, False, 2, False],
    "C1MCR2": [0xEF20, None, False, 2, False],
    "C1MCR3": [0xEF30, None, False, 2, False],
    "C1MCR4": [0xEF40, None, False, 2, False],
    "C1MCR5": [0xEF50, None, False, 2, False],
    "C1MCR6": [0xEF60, None, False, 2, False],
    "C1MCR7": [0xEF70, None, False, 2, False],
    "C1MCR8": [0xEF80, None, False, 2, False],
    "C1MCR9": [0xEF90, None, False, 2, False],
    "C1MCR10": [0xEFA0, None, False, 2, False],
    "C1MCR11": [0xEFB0, None, False, 2, False],
    "C1MCR12": [0xEFC0, None, False, 2, False],
    "C1MCR13": [0xEFD0, None, False, 2, False],
    "C1MCR14": [0xEFE0, None, False, 2, False],
    "C1MCR15": [0xEFF0, None, False, 2, False],
    "C1UAR1": [0xEF12, None, False, 2, False],
    "C1UAR2": [0xEF22, None, False, 2, False],
    "C1UAR3": [0xEF32, None, False, 2, False],
    "C1UAR4": [0xEF42, None, False, 2, False],
    "C1UAR5": [0xEF52, None, False, 2, False],
    "C1UAR6": [0xEF62, None, False, 2, False],
    "C1UAR7": [0xEF72, None, False, 2, False],
    "C1UAR8": [0xEF82, None, False, 2, False],
    "C1UAR9": [0xEF92, None, False, 2, False],
    "C1UAR10": [0xEFA2, None, False, 2, False],
    "C1UAR11": [0xEFB2, None, False, 2, False],
    "C1UAR12": [0xEFC2, None, False, 2, False],
    "C1UAR13": [0xEFD2, None, False, 2, False],
    "C1UAR14": [0xEFE2, None, False, 2, False],
    "C1UAR15": [0xEFF2, None, False, 2, False],
    "C1UGML": [0xEF08, None, False, 2, False],
    "C1UMLM": [0xEF0C, None, False, 2, False],
    "CAPREL": [0xFE4A, 0x25, False, 0, False],
    "CC0": [0xFE80, 0x40, False, 0, False],
    "CC0IC": [0xFF78, 0xBC, False, 0, True],
    "CC1": [0xFE82, 0x41, False, 0, False],
    "CC1IC": [0xFF7A, 0xBD, False, 0, True],
    "CC2": [0xFE84, 0x42, False, 0, False],
    "CC2IC": [0xFF7C, 0xBE, False, 0, True],
    "CC3": [0xFE86, 0x43, False, 0, False],
    "CC3IC": [0xFF7E, 0xBF, False, 0, True],
    "CC4": [0xFE88, 0x44, False, 0, False],
    "CC4IC": [0xFF80, 0xC0, False, 0, True],
    "CC5": [0xFE8A, 0x45, False, 0, False],
    "CC5IC": [0xFF82, 0xC1, False, 0, True],
    "CC6": [0xFE8C, 0x46, False, 0, False],
    "CC6IC": [0xFF84, 0xC2, False, 0, True],
    "CC7": [0xFE8E, 0x47, False, 0, False],
    "CC7IC": [0xFF86, 0xC3, False, 0, True],
    "CC8": [0xFE90, 0x48, False, 0, False],
    "CC8IC": [0xFF88, 0xC4, False, 0, True],
    "CC9": [0xFE92, 0x49, False, 0, False],
    "CC9IC": [0xFF8A, 0xC5, False, 0, True],
    "CC10": [0xFE94, 0x4A, False, 0, False],
    "CC10IC": [0xFF8C, 0xC6, False, 0, True],
    "CC11": [0xFE96, 0x4B, False, 0, False],
    "CC11IC": [0xFF8E, 0xC7, False, 0, True],
    "CC12": [0xFE98, 0x4C, False, 0, False],
    "CC12IC": [0xFF90, 0xC8, False, 0, True],
    "CC13": [0xFE9A, 0x4D, False, 0, False],
    "CC13IC": [0xFF92, 0xC9, False, 0, True],
    "CC14": [0xFE9C, 0x4E, False, 0, False],
    "CC14IC": [0xFF94, 0xCA, False, 0, True],
    "CC15": [0xFE9E, 0x4F, False, 0, False],
    "CC15IC": [0xFF96, 0xCB, False, 0, True],
    "CC16": [0xFE80, 0x40, False, 0, False],
    "CC16IC": [0xF180, 0xC0, False, 1, True],
    "CC17": [0xFE82, 0x41, False, 0, False],
    "CC17IC": [0xF182, 0xC1, False, 1, True],
    "CC18": [0xFE84, 0x42, False, 0, False],
    "CC18IC": [0xF184, 0xC2, False, 1, True],
    "CC19": [0xFE86, 0x43, False, 0, False],
    "CC19IC": [0xF186, 0xC3, False, 1, True],
    "CC20": [0xFE88, 0x44, False, 0, False],
    "CC20IC": [0xF188, 0xC4, False, 1, True],
    "CC21": [0xFE8A, 0x45, False, 0, False],
    "CC21IC": [0xF18A, 0xC5, False, 1, True],
    "CC22": [0xFE8C, 0x46, False, 0, False],
    "CC22IC": [0xF18C, 0xC6, False, 1, True],
    "CC23": [0xFE8E, 0x47, False, 0, False],
    "CC23IC": [0xF18E, 0xC7, False, 1, True],
    "CC24": [0xFE90, 0x48, False, 0, False],
    "CC24IC": [0xF190, 0xC8, False, 1, True],
    "CC25": [0xFE92, 0x49, False, 0, False],
    "CC25IC": [0xF192, 0xC9, False, 1, True],
    "CC26": [0xFE94, 0x4A, False, 0, False],
    "CC26IC": [0xF194, 0xCA, False, 1, True],
    "CC27": [0xFE96, 0x4B, False, 0, False],
    "CC27IC": [0xF196, 0xCB, False, 1, True],
    "CC28": [0xFE98, 0x4C, False, 0, False],
    "CC28IC": [0xF198, 0xCC, False, 1, True],
    "CC29": [0xFE9A, 0x4D, False, 0, False],
    "CC29IC": [0xF19A, 0xCD, False, 1, True],
    "CC30": [0xFE9C, 0x4E, False, 0, False],
    "CC30IC": [0xF19C, 0xCE, False, 1, True],
    "CC31": [0xFE9E, 0x4F, False, 0, False],
    "CC31IC": [0xF19E, 0xCF, False, 1, True],
    "CC16": [0xFE60, 0x30, False, 0, False],
    "CC16IC": [0xF160, 0xB0, False, 1, True],
    "CC17": [0xFE62, 0x31, False, 0, False],
    "CC17IC": [0xF162, 0xB1, False, 1, True],
    "CC18": [0xFE64, 0x32, False, 0, False],
    "CC18IC": [0xF164, 0xB2, False, 1, True],
    "CC19": [0xFE66, 0x33, False, 0, False],
    "CC19IC": [0xF166, 0xB3, False, 1, True],
    "CC20": [0xFE68, 0x34, False, 0, False],
    "CC20IC": [0xF168, 0xB4, False, 1, True],
    "CC21": [0xFE6A, 0x35, False, 0, False],
    "CC21IC": [0xF16A, 0xB5, False, 1, True],
    "CC22": [0xFE6C, 0x36, False, 0, False],
    "CC22IC": [0xF16C, 0xB6, False, 1, True],
    "CC23": [0xFE6E, 0x37, False, 0, False],
    "CC23IC": [0xF16E, 0xB7, False, 1, True],
    "CC24": [0xFE70, 0x38, False, 0, False],
    "CC24IC": [0xF170, 0xB8, False, 1, True],
    "CC25": [0xFE72, 0x39, False, 0, False],
    "CC25IC": [0xF172, 0xB9, False, 1, True],
    "CC26": [0xFE74, 0x3A, False, 0, False],
    "CC26IC": [0xF174, 0xBA, False, 1, True],
    "CC27": [0xFE76, 0x3B, False, 0, False],
    "CC27IC": [0xF176, 0xBB, False, 1, True],
    "CC28": [0xFE78, 0x3C, False, 0, False],
    "CC28IC": [0xF178, 0xBC, False, 1, True],
    "CC29": [0xFE7A, 0x3D, False, 0, False],
    "CC29IC": [0xF184, 0xC2, False, 1, True],
    "CC30": [0xFE7C, 0x3E, False, 0, False],
    "CC30IC": [0xF18C, 0xC6, False, 1, True],
    "CC31": [0xFE7E, 0x3F, False, 0, False],
    "CC31IC": [0xF194, 0xCA, False, 1, True],
    "CCM0": [0xFF52, 0xA9, False, 0, True],
    "CCM1": [0xFF54, 0xAA, False, 0, True],
    "CCM2": [0xFF56, 0xAB, False, 0, True],
    "CCM3": [0xFF58, 0xAC, False, 0, True],
    "CCM4": [0xFF22, 0x91, False, 0, True],
    "CCM5": [0xFF24, 0x92, False, 0, True],
    "CCM6": [0xFF26, 0x93, False, 0, True],
    "CCM7": [0xFF28, 0x94, False, 0, True],
    "CP": [0xFE10, 0x08, False, 0, False],
    "CRIC": [0xFF6A, 0xB5, False, 0, True],
    "CSP": [0xFE08, 0x04, True, 0, False],
    "DP0H": [0xF102, 0x81, False, 1, True],
    "DP0L": [0xF100, 0x80, False, 1, True],
    "DP1H": [0xF106, 0x83, False, 1, True],
    "DP1L": [0xF104, 0x82, False, 1, True],
    "DP2": [0xFFC2, 0xE1, False, 0, True],
    "DP3": [0xFFC6, 0xE3, False, 0, True],
    "DP4": [0xFFCA, 0xE5, False, 0, True],
    "DP6": [0xFFCE, 0xE7, False, 0, True],
    "DP7": [0xFFD2, 0xE9, False, 0, True],
    "DP8": [0xFFD6, 0xEB, False, 0, True],
    "DPP0": [0xFE00, 0x00, False, 0, False],
    "DPP1": [0xFE02, 0x01, False, 0, False],
    "DPP2": [0xFE04, 0x02, False, 0, False],
    "DPP3": [0xFE06, 0x03, False, 0, False],
    "EXICON": [0xF1C0, 0xE0, False, 1, True],
    "MDC": [0xFF0E, 0x87, False, 0, True],
    "MDH": [0xFE0C, 0x06, False, 0, False],
    "MDL": [0xFE0E, 0x07, False, 0, False],
    "ODP2": [0xF1C2, 0xE1, False, 1, True],
    "ODP3": [0xF1C6, 0xE3, False, 1, True],
    "ODP6": [0xF1CE, 0xE7, False, 1, True],
    "ODP7": [0xF1D2, 0xE9, False, 1, True],
    "ODP8": [0xF1D6, 0xEB, False, 1, True],
    "ONES": [0xFF1E, 0x8F, True, 0, False],
    "P0H": [0xFF02, 0x81, False, 0, True],
    "P0L": [0xFF00, 0x80, False, 0, True],
    "P1H": [0xFF06, 0x83, False, 0, True],
    "P1L": [0xFF04, 0x82, False, 0, True],
    "P2": [0xFFC0, 0xE0, False, 0, True],
    "P3": [0xFFC4, 0xE2, False, 0, True],
    "P4": [0xFFC8, 0xE4, False, 0, True],
    "P5": [0xFFA2, 0xD1, True, 0, True],
    "P5DIDIS": [0xFFA4, 0xD2, False, 0, True],
    "P6": [0xFFCC, 0xE6, False, 0, True],
    "P7": [0xFFD0, 0xE8, False, 0, True],
    "P8": [0xFFD4, 0xEA, False, 0, True],
    "PDCR": [0xF0AA, 0x55, False, 1, False],
    "PECC0": [0xFEC0, 0x60, False, 0, False],
    "PECC1": [0xFEC2, 0x61, False, 0, False],
    "PECC2": [0xFEC4, 0x62, False, 0, False],
    "PECC3": [0xFEC6, 0x63, False, 0, False],
    "PECC4": [0xFEC8, 0x64, False, 0, False],
    "PECC5": [0xFECA, 0x65, False, 0, False],
    "PECC6": [0xFECC, 0x66, False, 0, False],
    "PECC7": [0xFECE, 0x67, False, 0, False],
    "PICON": [0xF1C4, 0xE2, False, 1, False],
    "PP0": [0xF038, 0x1C, False, 1, False],
    "PP1": [0xF038, 0x1D, False, 1, False],
    "PP2": [0xF038, 0x1E, False, 1, False],
    "PP3": [0xF038, 0x1F, False, 1, False],
    "PSW": [0xFF10, 0x88, False, 0, True],
    "PT0": [0xF030, 0x18, False, 1, False],
    "PT1": [0xF032, 0x19, False, 1, False],
    "PT2": [0xF034, 0x1A, False, 1, False],
    "PT3": [0xF036, 0x1B, False, 1, False],
    "PW0": [0xFE30, 0x18, False, 0, False],
    "PW1": [0xFE32, 0x19, False, 0, False],
    "PW2": [0xFE34, 0x1A, False, 0, False],
    "PW3": [0xFE36, 0x1B, False, 0, False],
    "PWMCON0": [0xFF30, 0x98, False, 0, True],
    "PWMCON1": [0xFF32, 0x99, False, 0, True],
    "PWMIC": [0xF17E, 0xBF, False, 1, True],
    "RP0H": [0xF108, 0x84, True, 1, True],
    "S0BG": [0xFEB4, 0x5A, False, 0, False],
    "S0CON": [0xFFB0, 0xD8, False, 0, True],
    "S0EIC": [0xFF70, 0xB8, False, 0, True],
    "S0RBUF": [0xFEB2, 0x59, True, 0, False],
    "S0RIC": [0xFF6E, 0xB7, False, 0, True],
    "S0TBIC": [0xF19C, 0xCE, False, 1, True],
    "S0TBUF": [0xFEB0, 0x58, False, 0, False],
    "S0TIC": [0xFF6C, 0xB6, False, 1, True],
    "SP": [0xFE12, 0x09, False, 0, False],
    "SSCBR": [0xF0B4, 0x5A, False, 1, False],
    "SSCCON": [0xFFB2, 0xD9, False, 0, True],
    "SSCEIC": [0xFF76, 0xBB, False, 0, True],
    "SSCRB": [0xF0B2, 0x59, False, 1, False],
    "SSCRIC": [0xFF74, 0xBA, False, 0, True],
    "SSCTB": [0xF0B0, 0x58, False, 1, False],
    "SSCTIC": [0xFF72, 0xB9, False, 0, True],
    "STKOV": [0xFE14, 0x0A, False, 0, False],
    "STKUN": [0xFE16, 0x0B, False, 0, False],
    "SYSCON": [0xFF12, 0x89, False, 0, True],
    "T0": [0xFE50, 0x28, False, 0, False],
    "T1": [0xFE52, 0x29, False, 0, False],
    "T2": [0xFE40, 0x20, False, 0, False],
    "T3": [0xFE42, 0x21, False, 0, False],
    "T4": [0xFE44, 0x22, False, 0, False],
    "T5": [0xFE46, 0x23, False, 0, False],
    "T6": [0xFE48, 0x24, False, 0, False],
    "T7": [0xF050, 0x28, False, 1, False],
    "T8": [0xF052, 0x29, False, 1, False],
    "T0IC": [0xFF9C, 0xCE, False, 0, True],
    "T1IC": [0xFF9E, 0xCF, False, 0, True],
    "T2IC": [0xFF60, 0xB0, False, 0, True],
    "T3IC": [0xFF62, 0xB1, False, 0, True],
    "T4IC": [0xFF64, 0xB2, False, 0, True],
    "T5IC": [0xFF66, 0xB3, False, 0, True],
    "T6IC": [0xFF68, 0xB4, False, 0, True],
    "T7IC": [0xF17A, 0xBD, False, 1, True],
    "T8IC": [0xF17C, 0xBE, False, 1, True],
    "T0REL": [0xFE54, 0x2A, False, 0, False],
    "T1REL": [0xFE56, 0x2B, False, 0, False],
    "T7REL": [0xF054, 0x2A, False, 1, False],
    "T8REL": [0xF056, 0x2B, False, 1, False],
    "T01CON": [0xFF50, 0xA8, False, 0, True],
    "T2CON": [0xFF40, 0x20, False, 0, True],
    "T3CON": [0xFF42, 0xA1, False, 0, True],
    "T4CON": [0xFF44, 0xA2, False, 0, True],
    "T5CON": [0xFF46, 0xA3, False, 0, True],
    "T6CON": [0xFF48, 0xA4, False, 0, True],
    "T78CON": [0xFF20, 0x90, False, 0, True],
    "TFR": [0xFFAC, 0xD6, False, 0, True],
    "WDT": [0xFEAE, 0x57, True, 0, False],
    "WDTCON": [0xFFAE, 0xD7, False, 0, True],
    "XP0IC": [0xF186, 0xC3, False, 1, True],
    "XP1IC": [0xF18E, 0xC7, False, 1, True],
    "XP2IC": [0xF196, 0xCB, False, 1, True],
    "XP3IC": [0xF19E, 0xCF, False, 1, True],
    "ZEROS": [0xFF1C, 0x8E, True, 0, True],

    # XBUS registers according to freia (TODO: Find real documentation, 
    # C167 manual says these are not user-accessible)
    # NOTE: isBitaddrable cannot be set correctly until documentation is found
    "XPERCON": [0xF024, 0x12, False, 1, False],
    "XADDRS1": [0xF014, 0x0A, False, 1, False],
    "XADDRS2": [0xF016, 0x0B, False, 1, False],
    "XADDRS3": [0xF018, 0x0C, False, 1, False],
    "XADDRS4": [0xF01A, 0x0D, False, 1, False],
    "XADDRS5": [0xF01C, 0x0E, False, 1, False],
    "XADDRS6": [0xF01E, 0x0F, False, 1, False],
    "XBCON1": [0xF114, 0x8A, False, 1, True],
    "XBCON2": [0xF116, 0x8B, False, 1, True],
    "XBCON3": [0xF118, 0x8C, False, 1, True],
    "XBCON4": [0xF11A, 0x8D, False, 1, True],
    "XBCON5": [0xF11C, 0x8E, False, 1, True],
    "XBCON6": [0xF11E, 0x8F, False, 1, True],
    }

# All available register sets
sets = {
    "s45": s45_SFR
    }

def reglookup(reg: str, regset: str = "s45") -> int:
    return sets[regset][reg][1]

def regAddrLookup(reg: str, regset: str = "s45") -> int:
    return sets[regset][reg][0]

